.\"	$NetBSD: hardclock.9,v 1.1 2001/09/09 03:07:10 wiz Exp $
.\"
.\" Copyright (c) 2001 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Thomas Klausner.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 5, 2001
.Dt HARDCLOCK 9
.Os
.Sh NAME
.Nm hardclock
.Nd real-time timer
.Sh SYNOPSIS
.Ft void
.Fn hardclock "struct clockframe *"
.Sh DESCRIPTION
The
.Fn hardclock
function gets called
.Xr hz 9
times per second.
It performs different tasks:
.Bl -bullet -compact
.It
Run the current process's virtual and profile time (decrease the
corresponding timers, if they are activated, and generate
.Li SIGVTALRM
or
.Li SIGPROF ,
respectively).
.It
Increment the time-of-day, taking care of any
.Xr ntpd 8
or
.Xr adjtime 2
induced changes and leap seconds, as well as any necessary
compensations to keep in sync with PPS signals or external clocks, if
support for this is in the kernel (see
.Xr options 4 ) .
.It
Schedule softclock interrupts if any callouts should be triggered (see
.Xr callout 9 ) .
.El
.Sh SEE ALSO
.Xr adjtime 2 ,
.Xr ntp_adjtime 2 ,
.Xr signal 7 ,
.Xr ntpd 8 ,
.Xr callout 9 ,
.Xr hz 9
